<template>
  <div class="connect-modal fixed inset-0" @click="closeConnectModal">
    <div class="connect-modal__wrapper flex h-full items-center justify-center">
      <div
        id="connectModal"
        class="connect-modal__content relative animated-modal xs:w-full xs:absolute bottom-0 rounded-32 bg-bgdsec p-8 pb-12 xs:p-4 xs:pb-8 xs:rounded-none xs:rounded-t-32"
        @click.stop
      >
        <div class="flex items-center justify-between">
          <p class="text-txtdprim font-bold text-2xl leading-7 xs:text-lg xs:leading-5">{{ $t('connect.title') }}</p>
          <UiButton button-height="sm" color-type="secondary" class="w-12 rounded-16" @click="closeConnectModal">
            <img width="24" height="24" src="@/assets/images/connect-modal/cross.svg" />
          </UiButton>
        </div>
        <div class="mt-8 w-full flex items-center gap-4 relative">
          <div class="h-0.5 w-full absolute bottom-0 left-0 bg-brdddef rounded-100"></div>
          <div
            v-for="network in networks"
            :key="network.chainId"
            class="h-9 cursor-pointer relative hover:text-txtdprim px-1"
            :class="currentNetwork.chainId === network.chainId ? 'text-txtdprim' : 'text-txtdsec'"
            @click="chooseNetwork(network)"
          >
            <p class="text-center leading-5 font-medium">
              {{ network.title }}
            </p>
            <div
              v-show="currentNetwork.chainId === network.chainId"
              style="height: 3px; transform: translateY(0.5px)"
              class="w-full absolute bottom-0 left-0 rounded-100 bg-blue"
            ></div>
          </div>
        </div>
        <UiButton
          color-type="secondary"
          button-height="md"
          class="mt-8 rounded-24 w-full pl-4 pr-5 gap-3"
          @click="login"
        >
          <img width="32" height="32" src="@/assets/images/connect-modal/metamask.svg" />
          <p class="flex-1">MetaMask</p>
          <img v-if="!loading" width="24" height="24" src="@/assets/images/connect-modal/arrow-right.svg" />
          <LoadingSpinner v-else />
        </UiButton>
      </div>
    </div>
  </div>
</template>

<script>
import Cookies from 'js-cookie';
import UiButton from '@/components/ui/UiButton.vue';
import LoadingSpinner from '@/components/ui/LoadingSpinner.vue';

export default {
  name: 'ConnectModal',

  components: { UiButton, LoadingSpinner },

  data() {
    return {
      networks: [
        {
          title: 'Ethereum',
          key: 'ETH',
          chainId: 1,
        },
        {
          title: 'BNB Chain',
          key: 'BNB',
          chainId: 56,
        },
        {
          title: 'Polygon',
          key: 'MATIC',
          chainId: 137,
        },
      ],
    };
  },

  computed: {
    loading() {
      return this.$store.state.system.isWalletConnecting;
    },

    currentNetwork() {
      return this.$store.state.auth.currentNetwork;
    },
  },

  mounted() {
    this.checkNetwork();
  },

  methods: {
    closeConnectModal() {
      if (this.loading) return;
      this.$store.commit('setConnectModalDisplay', false);
    },

    chooseNetwork(network) {
      if (this.loading) return;
      this.$store.commit('setCurrentNetwork', network);
      Cookies.set('flashNetwork', network.key);
    },

    login() {
      this.$store.dispatch('linkWallet');
    },

    checkNetwork() {
      const networkKey = Cookies.get('flashNetwork');
      if (!networkKey) return;
      const network = this.networks.find((network) => network.key === networkKey);
      this.chooseNetwork(network);
    },
  },
};
</script>

<style lang="scss">
.connect-modal {
  background: rgba(12, 21, 33, 0.64);

  &__content {
    width: 480px;
  }
}
</style>
